if(typeof APMPlayerFactory==="undefined"){var APMPlayerFactory=function(){"use strict";var MediaTypes={type:{AUDIO:"audio",LIVE_AUDIO:"live_audio"},isValid:function(type){var key;for(key in MediaTypes.type){if(MediaTypes.type[key]===type){return true}}return false}};var Debug=function(){};Debug.enabled=false;Debug.consoleOnly=true;Debug.log=function(message,type,object_name){if(Debug.enabled===false){return}if(typeof soundManager!=="undefined"){if(typeof object_name==="undefined"){object_name="APMPlayer"}soundManager._writeDebug(object_name+"::"+message,type.id,false)}else{console.log(object_name+"::"+message+"["+type.name+"]")}};Debug.type={info:{id:1,name:"info"},warn:{id:2,name:"warning"},error:{id:3,name:"error"}};var Events=function(){this.type={AUDIO_LIB_READY:"AUDIO_LIB_READY",MEDIA_READY:"MEDIA_READY",PLAYER_READY:"PLAYER_READY",PLAYER_FAILURE:"PLAYER_FAILURE",CONNECTION_LOST:"CONNECTION_LOST",MISSING_FILE:"MISSING_FILE",PLAYLIST_CURRENT_CHANGE:"PLAYLIST_CURRENT_CHANGE",POSITION_UPDATE:"POSITION_UPDATE",PLAYING:"PLAYING",PAUSED:"PAUSED",FINISHED:"FINISHED",UNLOADED:"UNLOADED",BUFFER_START:"BUFFER_START",BUFFER_END:"BUFFER_END",METADATA:"METADATA",VOLUME_UPDATED:"VOLUME_UPDATED"};this.handlers=[]};Events.prototype={trigger:function(name,eventArgs){var i;for(i=0;i<this.handlers.length;i+=1){if(this.handlers[i].eventName===name){this.handlers[i].eventHandler.call(this,eventArgs)}}},addListener:function(name,handler){if(typeof name!=="string"||typeof handler!=="function"){Debug.log("Invalid parameters when creating listener with the following arguments: 'Name': "+name+", 'Handler': "+handler,Debug.type.error)}this.handlers.push({eventName:name,eventHandler:handler})},removeListeners:function(){this.handlers=[]}};var PlaybackState=function(){this.type={PLAYING:"PLAYING",STOPPED:"STOPPED",PAUSED:"PAUSED"};this._current=this.type.STOPPED};PlaybackState.prototype={current:function(){return this._current},set:function(state,playable){this._current=state;if(typeof playable==="object"&&playable.hasOwnProperty("state")){playable.state=this._current}}};var PlaybackMechanism=function(){this.type={FLASH:"FLASH",HTML5:"HTML5"};this.solutions=[this.type.FLASH,this.type.HTML5]};PlaybackMechanism.prototype={getCurrentSolution:function(){if(this.solutions.length>0){return this.solutions[0]}return null},removeCurrentSolution:function(){if(this.solutions.length>0){this.solutions.shift();return true}Debug.log("PlaybackMechanism.removeCurrentSolution() no playback solutions remain to remove!",Debug.type.error);return false},setSolutions:function(args){if(args instanceof Array){var valid_mechanisms=[];var mechanism;while(args.length>0){mechanism=args.shift();if(this.isValid(mechanism)){valid_mechanisms.push(mechanism)}else{Debug.log("PlaybackMechanism.setSolutions() passed mechanism '"+mechanism+"' is invalid.",Debug.type.error)}}this.solutions=valid_mechanisms;return true}Debug.log("PlaybackMechanism.setSolutions() argument passed is not an array!",Debug.type.error);return false},isValid:function(mechanism){var key;for(key in this.type){if(this.type[key]===mechanism){return true}}return false}};var CustomSchemes=function(){this.schemes=[];this.scheme_map={};this.playable_attrs=[]};CustomSchemes.prototype={init:function(scheme_map){this.scheme_map=scheme_map;this.initSchemeTypes();this.initPlayableAttrs()},initSchemeTypes:function(){this.schemes=[];for(var type in this.scheme_map){this.schemes.push(type)}},initPlayableAttrs:function(){this.playable_attrs=[];var playable=new Playable({});for(var propertyName in playable){if(typeof playable[propertyName]!=="function"){this.playable_attrs.push(propertyName)}}},hasSchemes:function(){if(this.schemes.length>0){return true}return false},isValid:function(scheme){if(this.schemes.indexOf(scheme)!==-1){return true}return false},isScheme:function(identifier,scheme){var result=this.parse(identifier);if(result!==null&&result.scheme===scheme){return true}return false},parse:function(identifier){var pattern="^("+this.schemes.join("|")+"){1}(:/){1}([/\\w .-]+$)";var regex=new RegExp(pattern);var result=identifier.match(regex);if(result!==null&&result.length===4){return{scheme:result[1],path:result[3]}}return null},getValues:function(identifier){var values={};var result=this.parse(identifier);if(result!==null&&this.isValid(result.scheme)){var type_map=this.scheme_map[result.scheme];if(type_map.hasOwnProperty(result.path)){type_map=type_map[result.path]}for(var prop in type_map){if(this.playable_attrs.indexOf(prop)!==-1){values[prop]=type_map[prop]}else if(prop==="flash_file_prefix"){values.flash_file_path=type_map[prop]+"/"+result.path}else if(prop==="http_file_prefix"){values.http_file_path=type_map[prop]+"/"+result.path}}}return values}};var custom_schemes=new CustomSchemes;var Playable=function(params){var playable_self=this;this.identifier=null;this.type=null;this.flash_file_path="";this.flash_server_url="";this.http_file_path="";this.buffer_time=3;this.downloadable=true;this.title="";this.description="";this.detail="";this.date="";this.program="";this.host="";this.image_sm="";this.image_lg="";this.duration=0;this.position=0;this.percent_played=0;this.percent_loaded=0;this.state="STOPPED";if(typeof params.identifier==="undefined"||params.identifier===null||params.identifier===""){return playable_self}(function(){playable_self.setMembers(params);if(custom_schemes.hasSchemes()){var configParams=custom_schemes.getValues(playable_self.identifier);playable_self.setMembers(configParams)}})()};Playable.prototype={isValid:function(){if(this.identifier!==null&&this.type!==null&&MediaTypes.isValid(this.type)){return true}return false},isCustomScheme:function(scheme){if(custom_schemes.isScheme(this.identifier,scheme)===true){return true}return false},isEOF:function(){if(this.percent_played>.99995){return true}return false},reset:function(){this.position=0;this.percent_played=0;this.percent_loaded=0},setEmptyMembers:function(params){var prop;for(prop in params){if(params.hasOwnProperty(prop)&&this.hasOwnProperty(prop)&&params[prop]!==null&&params[prop]!==""&&(this[prop]===null||this[prop]===""||this[prop]===0)){this[prop]=params[prop]}}},setMembers:function(params){for(var prop in params){if(params.hasOwnProperty(prop)&&this.hasOwnProperty(prop)){this[prop]=params[prop]}}},clearFlashProperties:function(){this.flash_server_url="";this.flash_file_path=""},isFlashStreamable:function(){if(this.flash_server_url!==""&&this.flash_file_path!==""){return true}return false}};var APMPlayer=function(){var player=this;var Audio=function(){this.lib=soundManager;this.init_status=false};Audio.prototype={init:function(){if(player.audio.init_status===false){this.lib.flashVersion=9;this.lib.preferFlash=true;this.lib.useHTML5Audio=true;this.lib.consoleOnly=Debug.consoleOnly;this.lib.debugMode=Debug.enabled;this.lib.flashPollingInterval=150;this.lib.url=player.util.getLoadedScriptPathByFileName("soundmanager2")+"swf/";this.lib.onready(function(){if(player.audio.lib.html5Only===true){player.mechanism.setSolutions([player.mechanism.type.HTML5]);Debug.log("Audio.init() -- setting to HTML5-only",Debug.type.info)}Debug.log("Audio.init() success",Debug.type.info);player.audio.init_status=true;player.internal_events.trigger(player.events.type.AUDIO_LIB_READY,{})});this.lib.ontimeout(function(status){if(!player.audio.lib.canPlayMIME("audio/mp3")&&!player.audio.lib.canPlayMIME("audio/mpeg")){player.mechanism.setSolutions([])}else{player.mechanism.setSolutions([player.mechanism.type.HTML5])}player.audio.reset()})}else{player.audio.reset();Debug.log("Audio.init() -- audio lib has already been initialized once, attempting reset",Debug.type.info)}},reset:function(){player.audio.init_status=false;var current_solution=player.mechanism.getCurrentSolution();switch(current_solution){case player.mechanism.type.FLASH:player.audio.lib.preferFlash=true;player.audio.lib.html5Only=false;break;case player.mechanism.type.HTML5:player.audio.lib.preferFlash=false;player.audio.lib.html5Only=true;break;default:Debug.log("Audio.reset() no playback solution exists.",Debug.type.error);player.events.trigger(player.events.type.PLAYER_FAILURE,null);return false}player.audio.lib.reboot()},load:function(playable){if(this.init_status===true){try{var sound;switch(player.mechanism.getCurrentSolution()){case player.mechanism.type.FLASH:sound={id:playable.identifier,url:playable.http_file_path,bufferTime:playable.buffer_time,onconnect:function(){Debug.log("Audio.load.lib.createSound.onConnect() - successfully connected over RTMP ("+playable.flash_server_url+")",Debug.type.info);player.internal_events.trigger(player.events.type.MEDIA_READY,playable)},onfailure:function(sound){var playable=player.current_playable;if(playable.position>0){Debug.log("Audio.load.createSound.onfailure() -- network connection has been lost",Debug.type.info);player.state.set(player.state.type.STOPPED,playable);player.events.trigger(player.events.type.CONNECTION_LOST,playable)}else if(sound.connected===true){Debug.log("Audio.load.createSound.onfailure() - requested file '"+playable.flash_file_path+"' w/ identifier '"+playable.identifier+"' could not be found in flash/RTMP mode.",Debug.type.error);player.state.set(player.state.type.STOPPED,playable);player.events.trigger(player.events.type.MISSING_FILE,playable);player.events.trigger(player.events.type.FINISHED,playable)}else{Debug.log("Audio.load.createSound.onfailure() - could not connect to '"+playable.flash_server_url+"' ... falling back to HTML5-mode.",Debug.type.error);player.state.set(player.state.type.STOPPED,playable);player.mechanism.removeCurrentSolution();player.audio.reset()}},onload:function(success){if(success===false){var playable=player.current_playable;player.events.trigger(player.events.type.MISSING_FILE,playable);Debug.log("Audio.load.createSound.onload() - could not load '"+playable.http_file_path+"' over progressive download",Debug.type.error)}}};if(playable.flash_file_path!==null&&playable.flash_file_path!==""&&playable.flash_server_url!==null&&playable.flash_server_url!==""){sound.serverURL=playable.flash_server_url;sound.url=playable.flash_file_path}this.lib.createSound(sound);break;case player.mechanism.type.HTML5:sound=this.lib.createSound({id:playable.identifier,url:playable.http_file_path,onload:function(success){var playable=player.current_playable;if(!success){player.state.set(player.state.type.STOPPED,playable);player.events.trigger(player.events.type.MISSING_FILE,playable);player.events.trigger(player.events.type.FINISHED,playable);Debug.log("Audio.load.createSound.onload():  requested file '"+playable.http_file_path+"' w/ identifier '"+playable.identifier+"' could not be found in HTML5 mode.",Debug.type.error)}else{if(this.duration){playable.duration=this.duration;Debug.log("Audio.load.createSound.onload(): duration found after start",Debug.type.info)}else{Debug.log("Audio.load.createSound.onload(): duration unknown",Debug.type.info)}}}});player.internal_events.trigger(player.events.type.MEDIA_READY,playable);break;default:Debug.log("Audio.load() no playback solution exists.",Debug.type.error);player.events.trigger(player.events.type.PLAYER_FAILURE,playable);break}}catch(e){Debug.log("Exception thrown in APMPlayer.Audio.load : "+e.toString(),Debug.type.error)}}else{if(player.mechanism.getCurrentSolution()===null){player.events.trigger(player.events.type.PLAYER_FAILURE,playable)}else{Debug.log("Audio.lib.load - audio lib not initialized.  load() will be called again when player is finally initialized.",Debug.type.info)}}},unload:function(playable){if(player.current_playable!==null){Debug.log("Audio.unload() about to stop, drop and roll current sound.",Debug.type.info);this.lib.destroySound(playable.identifier);playable.reset();player.state.set(player.state.type.STOPPED,playable);player.events.trigger(player.events.type.UNLOADED,playable)}},play:function(playable){if(!this.lib.getSoundById(playable.identifier)){this.load(playable)}else{Debug.log("Audio.play() attempting to play from lib.",Debug.type.info);this.lib.play(playable.identifier,{volume:player.settings.volume*100,position:playable.position,onplay:function(){player.state.set(player.state.type.PLAYING,playable);player.events.trigger(player.events.type.PLAYING,playable);player.events.trigger(player.events.type.METADATA,playable);if(player.settings.muted){this.mute()}Debug.log("Audio.play.onplay() PLAYING fired",Debug.type.info)},onpause:function(){player.state.set(player.state.type.PAUSED,playable);player.events.trigger(player.events.type.PAUSED,playable);Debug.log("Audio.play.onpause() PAUSED fired",Debug.type.info)},onresume:function(){player.state.set(player.state.type.PLAYING,playable);player.events.trigger(player.events.type.PLAYING,playable);Debug.log("Audio.play.onresume() PLAYING fired",Debug.type.info)},onfinish:function(){player.current_playable.reset();player.state.set(player.state.type.STOPPED,playable);player.events.trigger(player.events.type.FINISHED,playable);Debug.log("Audio.play.onfinish() FINISHED fired; playable reset.",Debug.type.info)},onbufferchange:function(){if(this.isBuffering===true){player.events.trigger(player.events.type.BUFFER_START,playable);Debug.log("Audio.play.onbufferchange() BUFFER_START fired ",Debug.type.info)}else{player.events.trigger(player.events.type.BUFFER_END,playable);Debug.log("Audio.play.onbufferchange() BUFFER_END fired ",Debug.type.info)}},whileplaying:function(){var playable=player.current_playable;if(playable.type===MediaTypes.type.LIVE_AUDIO){playable.percent_played=1;playable.duration=0;playable.position=this.position;player.events.trigger(player.events.type.POSITION_UPDATE,playable)}else{if(this.position!==0){playable.position=this.position}if(this.duration!==0&&this.duration>playable.duration){playable.duration=this.duration}if(this.durationEstimate>this.duration){playable.percent_loaded=this.duration/this.durationEstimate}else if(playable.percent_loaded>0&&playable.percent_loaded<1){playable.percent_loaded=1}if(playable.duration>0){playable.percent_played=playable.position/playable.duration}if(playable.isEOF()){playable.percent_played=1;playable.position=playable.duration}else{player.events.trigger(player.events.type.POSITION_UPDATE,playable)}}},onmetadata:function(){if(this.hasOwnProperty("metadata")){if(this.metadata.hasOwnProperty("adw_ad")&&this.metadata.adw_ad==="true"&&this.metadata.hasOwnProperty("metadata")&&this.metadata.metadata.indexOf("adswizzContext")!==-1){Debug.log("onmetadata() received adw_ad of insertionType: '"+this.metadata.insertionType+"'",Debug.type.info);playable.title="adw_ad_"+this.metadata.insertionType;playable.adw_context=this.metadata.metadata.substr(15);player.events.trigger(player.events.type.METADATA,playable)}else if(this.metadata.hasOwnProperty("StreamTitle")&&typeof this.metadata.StreamTitle!=="undefined"){Debug.log("onmetadata() received metadata w/ title: '"+this.metadata.StreamTitle+"'",Debug.type.info);playable.title=this.metadata.StreamTitle;player.events.trigger(player.events.type.METADATA,playable)}}}})}},pause:function(playable){var sound=this.lib.getSoundById(playable.identifier);if(sound){sound.pause();return true}Debug.log("Audio.pause() Error.  Could not pause.  '"+playable.identifier+"' is unknown.",Debug.type.warn);return false},unpause:function(playable){var sound=this.lib.getSoundById(playable.identifier);if(sound&&sound.paused===true){sound.resume();return true}Debug.log("Audio.unpause() Error.  Could not unpause.  '"+playable.identifier+"' is unknown.",Debug.type.warn);return false},seek:function(playable,percent_decimal){var sound=this.lib.getSoundById(playable.identifier);if(sound){if(playable.duration){Debug.log("Audio.seek() seeking to '"+percent_decimal+"' of sound '"+playable.identifier+"'",Debug.type.info);var msec=percent_decimal*playable.duration;sound.setPosition(msec);return true}Debug.log("Audio.seek() Error.  Could not seek. duration of '"+playable.identifier+"' is unknown.",Debug.type.warn);return false}Debug.log("Audio.seek() sound '"+playable.identifier+"' is unknown.",Debug.type.warn);return false},mute:function(playable){var sound=this.lib.getSoundById(playable.identifier);if(sound){sound.mute()}},unmute:function(playable){var sound=this.lib.getSoundById(playable.identifier);if(sound){sound.unmute()}},setVolume:function(playable,percent_decimal){var percent=percent_decimal*100;var sound=this.lib.getSoundById(playable.identifier);if(sound){Debug.log("Audio.setVolume() setting volume to "+percent+"% (out of 100)",Debug.type.info);sound.setVolume(percent)}else{Debug.log("Audio.setVolume() sound is not loaded.  volume will be set to "+percent+"% once audio begins playing",Debug.type.info)}}};this.settings={volume:.9,muted:false,debug:false};this.current_playable=null;this.events=new Events;this.internal_events=new Events;this.mechanism=new PlaybackMechanism;this.state=new PlaybackState;this.audio=new Audio;this.internal_event_handlers={checkReady:function(){if(player.audio.init_status===true){Debug.log("checkReady() player ready.  all dependencies loaded.",Debug.type.info);player.events.trigger(player.events.type.PLAYER_READY,{})}else{Debug.log("checkReady() not quite ready -- waiting for other dependencies to load...",Debug.type.info)}},onMediaReady:function(playable){player.audio.play(playable)}};this.internal_events.addListener(player.events.type.AUDIO_LIB_READY,player.internal_event_handlers.checkReady);this.internal_events.addListener(player.events.type.MEDIA_READY,player.internal_event_handlers.onMediaReady);this.util={getParameterByName:function(name){name=name.replace(/[\[]/,"\\[").replace(/[\]]/,"\\]");var regexS="[\\?&]"+name+"=([^&#]*)";var regex=new RegExp(regexS);var results=regex.exec(window.location.href);if(results===null){return""}return decodeURIComponent(results[1].replace(/\+/g," "))},getLoadedScriptPathByFileName:function(name){var scripts=document.getElementsByTagName("script");var numScripts=scripts.length;var index;for(index=0;index<numScripts;index+=1){var match=scripts[index].src.indexOf(name,0);if(match!==-1){return scripts[index].src.slice(0,match)}}},getProjectBasePath:function(){var path=player.util.getLoadedScriptPathByFileName("script/apmplayer-all.min.js");if(typeof path==="undefined"){path=player.util.getLoadedScriptPathByFileName("script/apmplayer.js")}return path},mergeSettings:function(settings){var prop;for(prop in settings){if(settings.hasOwnProperty(prop)&&player.settings.hasOwnProperty(prop)){player.settings[prop]=settings[prop]}}},checkDebug:function(){if(player.util.getParameterByName("debug")){Debug.enabled=true}if(player.util.getParameterByName("debug")==="all"){Debug.consoleOnly=false}},addIEFixes:function(){if(!Array.prototype.indexOf){Array.prototype.indexOf=function(elt){var len=this.length>>>0;var from=Number(arguments[1])||0;from=from<0?Math.ceil(from):Math.floor(from);if(from<0)from+=len;for(;from<len;from++){if(from in this&&this[from]===elt)return from}return-1}}}};return{init:function(){player.util.addIEFixes();player.util.checkDebug();player.audio.init()},reset:function(playback_solutions){if(playback_solutions instanceof Array){player.mechanism.setSolutions(playback_solutions)}player.audio.reset()},play:function(playable,settings){if(playable instanceof Playable){if(playable===player.current_playable&&player.state.current()!==player.state.type.PLAYING){switch(playable.type){case MediaTypes.type.AUDIO:case MediaTypes.type.LIVE_AUDIO:player.audio.play(playable);break;case MediaTypes.type.VIDEO:break;default:Debug.log("play() unsupported type: '"+playable.type+"'",Debug.type.error)}}else if(playable!==player.current_playable){if(player.mechanism.getCurrentSolution()===null){Debug.log("play()  insufficient playback mechanism for platform.  Triggered PLAYER_FAILURE",Debug.type.error);player.events.trigger(player.events.type.PLAYER_FAILURE,playable);return false}if(player.current_playable!==null){player.audio.unload(player.current_playable)}player.util.mergeSettings(settings);player.current_playable=playable;switch(playable.type){case MediaTypes.type.AUDIO:case MediaTypes.type.LIVE_AUDIO:player.audio.load(playable);break;case MediaTypes.type.VIDEO:break;default:Debug.log("load() unsupported type: '"+playable.type+"'",Debug.type.error);break}}}else{Debug.log("play() invalid playable passed.  must of of type Playable.  did nothing.",Debug.type.error);return false}},pause:function(){var playable=player.current_playable;if(playable!==null){switch(playable.type){case MediaTypes.type.AUDIO:player.audio.pause(playable);break;case MediaTypes.type.LIVE_AUDIO:player.audio.unload(playable);break;case MediaTypes.type.VIDEO:break;default:Debug.log("pause() unsupported type: '"+playable.type+"'",Debug.type.error)}}else{Debug.log("pause() no current playable loaded.  nothing to pause.",Debug.type.warn)}},unload:function(){var playable=player.current_playable;if(playable!==null){switch(playable.type){case MediaTypes.type.AUDIO:case MediaTypes.type.LIVE_AUDIO:player.audio.unload(playable);break;case MediaTypes.type.VIDEO:break;default:Debug.log("unload() unsupported type: '"+playable.type+"'",Debug.type.error)}}else{Debug.log("unload() no current playable loaded.  nothing to stop/unload.",Debug.type.info)}},seek:function(percent_decimal){var playable=player.current_playable;if(playable!==null){switch(playable.type){case MediaTypes.type.AUDIO:player.audio.seek(playable,percent_decimal);break;case MediaTypes.type.LIVE_AUDIO:Debug.log("seek() sorry, this item is not seekable '"+playable.identifier+"', type: '"+playable.type+"'",Debug.type.info);break;case MediaTypes.type.VIDEO:break;default:Debug.log("seek() unsupported type: '"+playable.type+"'",Debug.type.error)}}else{Debug.log("seek() no current playable loaded.  nothing to seek.",Debug.type.info)}},mute:function(){player.settings.muted=true;var playable=player.current_playable;if(playable!==null){switch(playable.type){case MediaTypes.type.AUDIO:case MediaTypes.type.LIVE_AUDIO:player.audio.mute(playable);break;case MediaTypes.type.VIDEO:break;default:Debug.log("mute() unsupported type: '"+playable.type+"'",Debug.type.error);break}}Debug.log("mute() -- player is now muted.",Debug.type.info)},unmute:function(){player.settings.muted=false;var playable=player.current_playable;if(playable!==null){switch(playable.type){case MediaTypes.type.AUDIO:case MediaTypes.type.LIVE_AUDIO:player.audio.unmute(playable);break;case MediaTypes.type.VIDEO:break;default:Debug.log("unmute() unsupported type: '"+playable.type+"'",Debug.type.error);break}}Debug.log("unmute() -- player is now unmuted.",Debug.type.info)},setVolume:function(percent_decimal){if(percent_decimal<0){percent_decimal=0;Debug.log("setVolume() invalid percent_decimal passed: '"+percent_decimal+"' is less than 0.  percent_decimal set to 0.  percentages must be represented as a decimal from 0 to 1 (eg .45)",Debug.type.warn)}else if(percent_decimal>1){percent_decimal=1;Debug.log("setVolume() invalid percent_decimal passed: '"+percent_decimal+"' is greater than 1.  percent_decimal set to 1.00 by default.  percentages must be represented as a decimal from 0.00 to 1.00 (eg .45)",Debug.type.warn)}var playable=player.current_playable;if(playable!==null){switch(playable.type){case MediaTypes.type.AUDIO:case MediaTypes.type.LIVE_AUDIO:player.audio.setVolume(playable,percent_decimal);break;case MediaTypes.type.VIDEO:break;default:Debug.log("setVolume() unsupported type: '"+playable.type+"'",Debug.type.error)}}else{Debug.log("setVolume() no playable loaded.  VOLUME_UPDATED event still fired. new vox : '"+percent_decimal+"'",Debug.type.info)}player.settings.volume=percent_decimal;player.events.trigger(player.events.type.VOLUME_UPDATED,{percent_decimal:percent_decimal})},debug:Debug,events:player.events,mechanism:player.mechanism,mediaTypes:MediaTypes.type,state:player.state,base_path:player.util.getProjectBasePath()}};var Playlist=function(){this.events=new Events;this._items=[];this._current_index=null};Playlist.prototype={add:function(playable){if(playable instanceof Playable&&playable.isValid()){if(this.item(playable.identifier)!==null){Debug.log("add() could not add '"+playable.identifier+"' to playlist because it already exists!",Debug.type.warn,"Playlist");return false}this._items.push(playable);if(this._current_index===null){this._current_index=0;this.events.trigger(this.events.type.PLAYLIST_CURRENT_CHANGE,null)}Debug.log("add() new playable successfully added to playlist: '"+playable.identifier+"'",Debug.type.info,"Playlist");return true}Debug.log("add() -- error: nothing added to playlist.  either object passed was not of type Playable or identifier '"+playable.identifier+"' is invalid.",Debug.type.warn,"Playlist");return false},_count:function(){return this._items.length},current:function(){if(this._current_index!==null){return this._items[this._current_index]}return null},item:function(identifier){var j,total_items=this._count();for(j=0;j<total_items;j+=1){if(this._items[j].identifier===identifier){return this._items[j]}}return null},"goto":function(identifier){var j,total_items=this._count();for(j=0;j<total_items;j+=1){if(this._items[j].identifier===identifier){var previous_playable=this.current();this._current_index=j;this.events.trigger(this.events.type.PLAYLIST_CURRENT_CHANGE,previous_playable);return true}}Debug.log("goto() - invalid identifier passed '"+identifier+"'.  This was not found in the current playlist!",Debug.type.warn,"Playlist");return false},hasNext:function(){if(this._current_index+1<this._count()){return true}return false},remove:function(identifier){var j,num_items_before_remove=this._count();for(j=0;j<num_items_before_remove;j+=1){if(this._items[j].identifier===identifier){if(this.current().identifier===identifier){Debug.log("remove() -- sorry, you may not remove the current item in the playlist. returning false.)",Debug.type.warn,"Playlist");return false}this._items.splice(j,1);if(this._current_index>0&&j<=this._current_index){this._current_index-=1}return true}}return false},next:function(){if(this._current_index!==null){Debug.log("next() advancing to next position in playlist (or to beginning if at last)",Debug.type.info,"Playlist");var previous_playable=this.current();this._current_index=this._current_index+1<this._count()?this._current_index+1:0;this.events.trigger(this.events.type.PLAYLIST_CURRENT_CHANGE,previous_playable)}else{return false}},previous:function(){if(this._current_index!==null){Debug.log("previous() moving to previous position in playlist (or to last if at beginning)",Debug.type.info,"Playlist");var previous_playable=this.current();this._current_index=this._current_index-1>=0?this._current_index-1:this._count()-1;this.events.trigger(this.events.type.PLAYLIST_CURRENT_CHANGE,previous_playable)}else{return false}}};var apmplayer_instance;return{getPlayer:function(){if(typeof apmplayer_instance==="undefined"){apmplayer_instance=new APMPlayer;apmplayer_instance.constructor=null}return apmplayer_instance},getPlayable:function(params){return new Playable(params)},getPlaylist:function(){return new Playlist},getCustomSchemes:function(){return custom_schemes}}}()}var scheme_map={apm_audio:{flash_server_url:"rtmp://archivemedia.publicradio.org/music",flash_file_prefix:"mp3:ondemand",http_file_prefix:"http://ondemand.publicradio.org",buffer_time:3,type:"audio"},apm_live_audio:{mpr_news:{flash_server_url:"rtmp://archivemedia.publicradio.org/news",flash_file_path:"news.stream",http_file_path:"http://newsstream1.publicradio.org:80/",buffer_time:6,type:"live_audio"},mpr_current:{flash_server_url:"rtmp://archivemedia.publicradio.org/kcmp",flash_file_path:"kcmp.stream",http_file_path:"http://currentstream1.publicradio.org:80/",buffer_time:6,type:"live_audio"},csf:{flash_server_url:"rtmp://archivemedia.publicradio.org/csf",flash_file_path:"csf.stream",http_file_path:"http://204.93.222.85:80/csf-nopreroll",buffer_time:6,type:"live_audio"},wpbi:{flash_server_url:"rtmp://archivemedia.publicradio.org/wpbistream",flash_file_path:"wpbi.stream",http_file_path:"http://wpbistream1.lbdns-streamguys.com:80/wpbistream",buffer_time:6,type:"live_audio"}}};var custom_schemes=APMPlayerFactory.getCustomSchemes();custom_schemes.init(scheme_map);var APMPlayer=APMPlayerFactory.getPlayer();APMPlayer.init();(function($){"use strict";var APMPlayerUI=function(jq_element,jq_args){var player_ui=this;this.parent_id="#"+jq_element.attr("id");this.args=jq_args;this.init=function(){player_ui.main.init();player_ui.controls.init();player_ui.events.init();player_ui.playlist.init()};this.main={settings:{autoplay:false,muted:false,fetchMetadata:false,volume:.9},isReady:false,init:function(){if(player_ui.args.hasOwnProperty("settings")){player_ui.main.mergeSettings(player_ui.args.settings)}if(player_ui.main.settings.autoplay===true&&player_ui.main.settings.fetchMetadata===true){player_ui.main.settings.autoplay="wait"}},mergeSettings:function(settings){var prop;for(prop in settings){if(settings.hasOwnProperty(prop)&&player_ui.main.settings.hasOwnProperty(prop)){player_ui.main.settings[prop]=settings[prop]}}},canAutoPlay:function(){if(player_ui.main.settings.autoplay===true&&APMPlayer.mechanism.getCurrentSolution()!==APMPlayer.mechanism.type.HTML5&&player_ui.main.isReady===true){return true}return false},updateAutoPlay:function(playable){var current_playable=player_ui.playlist.current();if(current_playable.identifier===playable.identifier&&player_ui.main.settings.autoplay==="wait"){player_ui.main.settings.autoplay=true}},fetchMetadata:function(playable){player_ui.events.onFetchMetadata(playable)}};this.skin={css:{play:"apm_player_play",pause:"apm_player_pause",seeker:"apm_player_bar",seekerBufferingCls:"buffering",seekerLoading:"apm_player_loading",liveStreamingCls:"streaming",volumeWrapper:"apm_player_volume_wrapper",volumeMutedCls:"muted",volumeBar:"apm_volume_bar",volumeBarWrapper:"apm_player_volume_slider_wrapper",volumeStatus:"apm_player_volume_status",info:"apm_player_info",status:"apm_player_status",statusWarningCls:"warning",statusAlertCls:"alert",playtime:"apm_player_playtime",playlist:"apm_playlist",playlistNowPlayingCls:"nowplaying",sponsorOverlayActiveCls:"preroll-active",sponsorOverlayInactiveCls:"preroll-inactive",sponsorTimer:"apm_sponsor_overlay_time",sharingTools:"apm_sharing_tools",sharingTabControls:"apm_sharing_tab_controls",sharingTabCls:"apm_sharing_tab",sharingTabSharing:"apm_sharing_share",sharingTabDownload:"apm_sharing_download",sharingTabEmbed:"apm_sharing_embed",sharingTabLink:"apm_sharing_link"}};this.controls={init:function(){player_ui.controls.seeker.init();player_ui.controls.info.init();player_ui.controls.volume.init();player_ui.controls.volumeStatus.init();player_ui.controls.pause.init();player_ui.controls.play.init();player_ui.controls.tools.init()},play:{init:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.play).click(function(){APMPlayer.play(player_ui.playlist.current(),player_ui.main.settings)})}},pause:{init:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.pause).click(function(){APMPlayer.pause()})}},seeker:{status:"NORMAL",init:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).slider({disabled:true,range:"min",start:function(event,ui){player_ui.controls.seeker.status="USER_SLIDING"},stop:function(event,ui){player_ui.events.onSeek(ui.value/100);player_ui.controls.seeker.status="NORMAL"},slide:function(event,ui){player_ui.controls.seeker.status="USER_SLIDING";var current_playable=player_ui.playlist.current();current_playable.position=ui.value/100*current_playable.duration;player_ui.controls.playtime.render(current_playable)}})},update:function(playable){if(player_ui.controls.seeker.status==="NORMAL"){var percent=100*playable.percent_played;$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).slider("value",percent)}if(playable.percent_loaded<=1){var percent_num=100*playable.percent_loaded;$(player_ui.parent_id+" #"+player_ui.skin.css.seekerLoading).width(percent_num+"%")}},enable:function(){if(player_ui.playlist.current().type!==APMPlayer.mediaTypes.LIVE_AUDIO){$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).slider("enable")
}},disable:function(){if(player_ui.playlist.current().type===APMPlayer.mediaTypes.LIVE_AUDIO){$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).slider("disable")}},reset:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).slider("value",0)},configure:function(playable){player_ui.controls.seeker.reset();if(playable.type===APMPlayer.mediaTypes.LIVE_AUDIO){player_ui.controls.seeker.disable();$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).addClass(player_ui.skin.css.liveStreamingCls)}else{if(playable.duration>0){player_ui.controls.seeker.enable()}$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).removeClass(player_ui.skin.css.liveStreamingCls)}}},playtime:{convertToTime:function(miliseconds){var myTime=new Date(miliseconds),hour=myTime.getUTCHours(),min=myTime.getUTCMinutes(),sec=myTime.getUTCSeconds(),strHour=hour,strMin=strHour>0&&min<10?"0"+min:min,strSec=sec<10?"0"+sec:sec;return(strHour>0?strHour+":":"")+(strMin+":")+strSec},render:function(playable){var time_display;if(playable.duration>0){time_display=player_ui.controls.playtime.convertToTime(playable.position)+" / "+player_ui.controls.playtime.convertToTime(playable.duration)}else{time_display=player_ui.controls.playtime.convertToTime(playable.position)}$(player_ui.parent_id+" #"+player_ui.skin.css.playtime).text(time_display)}},volume:{init:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeBar).slider({range:"min",orientation:"vertical",value:player_ui.main.settings.volume*100,stop:function(event,ui){APMPlayer.setVolume(ui.value/100);if(ui.value>0){if(player_ui.main.settings.muted){APMPlayer.unmute();player_ui.controls.volumeStatus.renderUnmuted();player_ui.main.settings.muted=false}}}});$(player_ui.parent_id+" #"+player_ui.skin.css.volumeWrapper).hover(function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeBarWrapper).show()},function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeBarWrapper).fadeOut(500)})},renderMuted:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeBar).slider("value",0)},renderUnmuted:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeBar).slider("value",player_ui.main.settings.volume*100)}},volumeStatus:{init:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeStatus).click(function(){if(player_ui.main.settings.muted){APMPlayer.unmute();player_ui.main.settings.muted=false;player_ui.controls.volume.renderUnmuted();player_ui.controls.volumeStatus.renderUnmuted()}else{APMPlayer.mute();player_ui.main.settings.muted=true;player_ui.controls.volume.renderMuted();player_ui.controls.volumeStatus.renderMuted()}})},renderMuted:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeStatus).addClass(player_ui.skin.css.volumeMutedCls)},renderUnmuted:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.volumeStatus).removeClass(player_ui.skin.css.volumeMutedCls)}},info:{init:function(){if(player_ui.args.hasOwnProperty("onMetadata")){player_ui.events.onMetadata=player_ui.args.onMetadata}}},status:{displayWarning:function(html_snippet){$(player_ui.parent_id+" #"+player_ui.skin.css.status).html(html_snippet);$(player_ui.parent_id+" #"+player_ui.skin.css.status).addClass(player_ui.skin.css.statusWarningCls)},displayAlert:function(html_snippet){$(player_ui.parent_id+" #"+player_ui.skin.css.status).html(html_snippet);$(player_ui.parent_id+" #"+player_ui.skin.css.status).addClass(player_ui.skin.css.statusAlertCls)},clearAll:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.status).removeClass(player_ui.skin.css.statusAlertCls);$(player_ui.parent_id+" #"+player_ui.skin.css.status).removeClass(player_ui.skin.css.statusWarningCls);$(player_ui.parent_id+" #"+player_ui.skin.css.status).html("")}},tools:{init:function(){if(player_ui.args.hasOwnProperty("tools")&&player_ui.args.tools.hasOwnProperty("config")){player_ui.controls.tools.config=player_ui.args.tools.config}player_ui.controls.tools.config()},config:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.sharingTools+" ."+player_ui.skin.css.sharingTabCls).hide();$(player_ui.parent_id+" #"+player_ui.skin.css.sharingTools+" ."+player_ui.skin.css.sharingTabCls+":first").show();$(player_ui.parent_id+" #"+player_ui.skin.css.sharingTools+" ul#"+player_ui.skin.css.sharingTabControls+" li:first").addClass("active");$(player_ui.parent_id+" #"+player_ui.skin.css.sharingTools+" ul#"+player_ui.skin.css.sharingTabControls+" li a").click(function(){$(player_ui.parent_id+" #"+player_ui.skin.css.sharingTools+" ul#"+player_ui.skin.css.sharingTabControls+" li").removeClass("active");$(this).parent().addClass("active");var currentTab=$(this).attr("href");$(player_ui.parent_id+" #"+player_ui.skin.css.sharingTools+" ."+player_ui.skin.css.sharingTabCls).hide();$(currentTab).show();return false})},renderDownload:function(playable){var snippet="";if(playable.downloadable===true&&player_ui.playlist.current().type===APMPlayer.mediaTypes.AUDIO){snippet='<a href="'+APMPlayer.base_path+"util/download.php?uri="+playable.http_file_path+'">file download</a>'}else{snippet="sorry, this item is not downloadable."}$(player_ui.parent_id+" #"+player_ui.skin.css.sharingTools+" #"+player_ui.skin.css.sharingTabDownload).html(snippet)}}};this.events={init:function(){APMPlayer.events.addListener(APMPlayer.events.type.PLAYER_READY,player_ui.events.onPlayerReady);APMPlayer.events.addListener(APMPlayer.events.type.PLAYING,player_ui.events.onPlaying);APMPlayer.events.addListener(APMPlayer.events.type.PAUSED,player_ui.events.onPaused);APMPlayer.events.addListener(APMPlayer.events.type.METADATA,player_ui.events.onMetadata);APMPlayer.events.addListener(APMPlayer.events.type.BUFFER_START,player_ui.events.onBufferStart);APMPlayer.events.addListener(APMPlayer.events.type.BUFFER_END,player_ui.events.onBufferEnd);APMPlayer.events.addListener(APMPlayer.events.type.POSITION_UPDATE,player_ui.events.onPositionUpdate);APMPlayer.events.addListener(APMPlayer.events.type.FINISHED,player_ui.events.onFinished);APMPlayer.events.addListener(APMPlayer.events.type.UNLOADED,player_ui.events.onUnloaded);APMPlayer.events.addListener(APMPlayer.events.type.VOLUME_UPDATED,player_ui.events.onVolumeUpdated);APMPlayer.events.addListener(APMPlayer.events.type.CONNECTION_LOST,player_ui.events.onConnectionLost);APMPlayer.events.addListener(APMPlayer.events.type.PLAYER_FAILURE,player_ui.events.onFailure);APMPlayer.events.addListener(APMPlayer.events.type.MISSING_FILE,player_ui.events.onMissingFile)},onPlayerReady:function(){player_ui.main.isReady=true;if(player_ui.main.canAutoPlay()){APMPlayer.play(player_ui.playlist.current(),player_ui.main.settings)}else{var current_playable=player_ui.playlist.current();if(current_playable!==null){player_ui.events.onMetadata(current_playable)}}},onPlaying:function(playable){player_ui.controls.seeker.enable();player_ui.controls.status.clearAll();$(player_ui.parent_id+" #"+player_ui.skin.css.play).hide();$(player_ui.parent_id+" #"+player_ui.skin.css.pause).show();player_ui.playlist.addNowPlaying(playable)},onPaused:function(playable){$(player_ui.parent_id+" #"+player_ui.skin.css.play).show();$(player_ui.parent_id+" #"+player_ui.skin.css.pause).hide();if(playable.type===APMPlayer.mediaTypes.LIVE_AUDIO){player_ui.controls.seeker.reset()}},onFinished:function(){player_ui.controls.seeker.disable();if(player_ui.playlist.hasNext()){player_ui.playlist.next()}else{APMPlayer.unload()}},onPositionUpdate:function(playable){player_ui.controls.seeker.update(playable);if(player_ui.controls.seeker.status!=="USER_SLIDING"){player_ui.controls.playtime.render(playable)}},onSeek:function(percent_decimal){if(APMPlayer.state.current()!==APMPlayer.state.type.STOPPED){APMPlayer.seek(percent_decimal)}else{var current_playable=player_ui.playlist.current();if(current_playable.duration>0){current_playable.percent_played=percent_decimal;current_playable.position=current_playable.duration*percent_decimal;player_ui.controls.playtime.render(current_playable)}}},onUnloaded:function(playable){player_ui.controls.seeker.reset();player_ui.controls.playtime.render(playable);$(player_ui.parent_id+" #"+player_ui.skin.css.play).show();$(player_ui.parent_id+" #"+player_ui.skin.css.pause).hide()},onBufferStart:function(){if(APMPlayer.state.current()===APMPlayer.state.type.PLAYING){$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).addClass(player_ui.skin.css.seekerBufferingCls)}},onBufferEnd:function(){$(player_ui.parent_id+" #"+player_ui.skin.css.seeker).removeClass(player_ui.skin.css.seekerBufferingCls)},onFetchMetadata:function(response){APMPlayer.debug.log("events.onFetchMetadata() pass-through hit for  '"+response.identifier+"'",APMPlayer.debug.type.info,"APMPlayerUI");var current_playable=player_ui.playlist.current();if(response.identifier===current_playable.identifier){player_ui.events.onMetadata(current_playable);player_ui.controls.tools.renderDownload(current_playable);if(current_playable.duration>0){player_ui.controls.playtime.render(current_playable);if(current_playable.isFlashStreamable()){player_ui.controls.seeker.enable();if(current_playable.position>0){current_playable.percent_played=current_playable.position/current_playable.duration}player_ui.controls.seeker.update(current_playable)}}player_ui.main.updateAutoPlay(current_playable);if(player_ui.main.canAutoPlay()){APMPlayer.play(player_ui.playlist.current(),player_ui.main.settings)}}},onMetadata:function(){},onFailure:function(){var playable=player_ui.playlist.current();var snippet='<p>We\'re sorry, but your browser is not able to play the stream.  Please try one of these options:  <br /><br />1) Install or enable <a href="http://get.adobe.com/flashplayer/" target="_blank">Adobe Flash Player</a> <br />2) Use a browser that supports HTML5 and MP3 audio, such as <a href="http://www.google.com/chrome/" target="_blank">Chrome</a>, <a href="http://www.apple.com/safari/download/" target="_blank">Safari</a>, or <a href="http://www.microsoft.com/ie9" target="_blank">Internet Explorer 9</a>';if(/Safari/.test(navigator.userAgent)&&/Apple Computer/.test(navigator.vendor)){snippet='<p>We\'re sorry, but your browser is not able to play the stream.  Please try one of these options:  <br /><br />1) Install or enable <a href="http://get.adobe.com/flashplayer/" target="_blank">Adobe Flash Player</a> <br />2) Install <a href="http://www.apple.com/quicktime/download/" target="_blank">Quicktime</a> for HTML5 support for Safari on Windows (requires reboot) <br />2b) Use a different browser that natively supports HTML5 and MP3 audio, such as <a href="http://www.google.com/chrome/" target="_blank">Chrome</a> or <a href="http://www.microsoft.com/ie9" target="_blank">Internet Explorer 9</a>'}if(playable.downloadable===true&&playable.http_file_path!==""){if(playable.type===APMPlayer.mediaTypes.AUDIO){snippet+='<br />3) <a href="'+APMPlayer.base_path+"util/download.php?uri="+playable.http_file_path+'">download the audio</a>'}else if(playable.type===APMPlayer.mediaTypes.LIVE_AUDIO){snippet+='<br />3) <a href="'+playable.http_file_path+'">Stream the audio using a third-party player (eg. iTunes)</a>'}}snippet+="</p>";player_ui.controls.status.displayWarning(snippet)},onVolumeUpdated:function(eventData){player_ui.main.settings.volume=eventData.percent_decimal},onConnectionLost:function(){APMPlayer.unload();var snippet="<p>Your network connection has changed or has been lost.<br /><br />Please check your connection, then click play to resume.";player_ui.controls.status.displayAlert(snippet)},onMissingFile:function(playable){var snippet="<p>We're sorry, an error has occurred and your audio cannot be played at this time. <br /><br />Often, this error is a result of a poor or missing internet connection.  Please check your internet connection, then click play to resume.";player_ui.controls.status.displayWarning(snippet);player_ui.underwriting.removeOverlay()}};this.playlist=APMPlayerFactory.getPlaylist();player_ui.playlist.onUpdate=function(playable){};player_ui.playlist.init=function(){if(player_ui.args.hasOwnProperty("onPlaylistUpdate")){player_ui.playlist.onUpdate=player_ui.args.onPlaylistUpdate}if(player_ui.args.hasOwnProperty("playables")){$.each(player_ui.args.playables,function(index,item){player_ui.playlist.addPlayable(item)})}};player_ui.playlist.addPlayable=function(item){var playable=APMPlayerFactory.getPlayable(item);if(playable.isValid()){player_ui.playlist.add(playable);player_ui.playlist.onUpdate(playable);if(player_ui.main.settings.fetchMetadata===true){if(playable.isCustomScheme("apm_audio")){player_ui.main.fetchMetadata(playable)}else{player_ui.main.updateAutoPlay(playable)}}}else{APMPlayer.debug.log("sorry, there was a problem with the parameters passed and a valid playable could not be created.",APMPlayer.debug.type.warn,"APMPlayerUI")}};player_ui.playlist.gotoItem=function(identifer){if(APMPlayer.state.current()===APMPlayer.state.type.STOPPED||player_ui.playlist.current().identifier!==identifer){player_ui.controls.seeker.disable();player_ui.playlist.goto(identifer)}};player_ui.playlist.addNowPlaying=function(playable){$("li[ id = '"+playable.identifier+"']").addClass(player_ui.skin.css.playlistNowPlayingCls)};player_ui.playlist.removeNowPlaying=function(playable){$(player_ui.parent_id+" #"+player_ui.skin.css.playlist+" li[ id = '"+playable.identifier+"']").removeClass(player_ui.skin.css.playlistNowPlayingCls)};player_ui.playlist.onCurrentChange=function(previous_playable){if(previous_playable!==null){player_ui.playlist.removeNowPlaying(previous_playable);APMPlayer.play(player_ui.playlist.current(),player_ui.main.settings)}var current_playable=player_ui.playlist.current();player_ui.controls.seeker.configure(current_playable);player_ui.controls.tools.renderDownload(current_playable);if(current_playable.duration>0){player_ui.controls.playtime.render(current_playable)}};player_ui.playlist.events.addListener(APMPlayer.events.type.PLAYLIST_CURRENT_CHANGE,player_ui.playlist.onCurrentChange);player_ui.init()};$.fn.apmplayer_ui=function(args){if(typeof APMPlayer==="undefined"||typeof soundManager==="undefined"){$.error("apmplayer_ui ERROR.  1 or more dependent libraries missing.  exiting.");return null}var jq_element=this,methods={addPlayable:function(item){if(typeof window.apmplayer_ui!=="undefined"){window.apmplayer_ui.playlist.addPlayable(item)}else{APMPlayer.debug.log("you must first initialize apmplayer_ui before calling methods on it.",APMPlayer.debug.type.error,"APMPlayerUI")}},gotoPlaylistItem:function(identifier){if(typeof window.apmplayer_ui!=="undefined"){window.apmplayer_ui.playlist.gotoItem(identifier)}else{APMPlayer.debug.log("you must first initialize apmplayer_ui before calling methods on it.",APMPlayer.debug.type.error,"APMPlayerUI")}}};if(methods[args]){return methods[args].apply(this,Array.prototype.slice.call(arguments,1))}else if(typeof args==="object"||!args){if(typeof window.apmplayer_ui==="undefined"){window.apmplayer_ui=new APMPlayerUI(jq_element,args);APMPlayer.debug.log("instantiated apmplayer_ui",APMPlayer.debug.type.info,"APMPlayerUI")}else{APMPlayer.debug.log("sorry, only one player UI instance is currently supported.",APMPlayer.debug.type.error,"APMPlayerUI")}}else{APMPlayer.debug.log("Method "+args+" does not exist on jQuery.apmplayer_ui",APMPlayer.debug.type.error,"APMPlayerUI")}}})(jQuery)